# Praktikum 12 aruanne

Antud praktikumis sain kirjutada Linux'is skripte, mida kontrollisin programmiga `shellcheck`, et teha 
skriptid korrektsemaks. Lisaks suutsin kõik skriptid kirjutada `sh` kestaga, võimaldades paremat ühilduvust võrreldes
`bash`-iga.

## Ülesanne 3
```sh
#!/bin/sh
printf "Nimi: "
read -r nimi
printf "Eriala: "
read -r eriala
printf "Matriklinumber: "
read -r matriklinumber
echo "Tere $nimi, kes õpib erialal $eriala ja on seal $matriklinumber. matrikkel!"
```

![Tõestus](images/praktikum12.3.png)

## Ülesanne 4
```sh
#!/bin/sh

for f in ./*
do
        case $f in
                *$1) mv "$f" "$(echo "$f" | sed "s/$1/$2/")";;
                *) true;;
        esac
done
```

![Tõestus](images/praktikum12.4.png)

## Ülesanne 5
```sh
#!/bin/sh
ps -A | tr -s " " | cut -d " " -f 2,5 | grep "$1"
```

![Tõestus](images/praktikum12.5.png)

## Ülesanne 6
```
#!/bin/sh

pow() {
        a=$1
        b=$2
        c=1
        while [ "$b" -gt 0 ]
        do
                c=$((a*c))
                b=$((b-1))
        done
        echo $c
}

pow "$1" "$2"
```

![Tõestus](images/praktikum12.6.png)

## Ülesanne 7

![Tõestus](images/praktikum12a.png)
![Tõestus](images/praktikum12b.png)
![Tõestus](images/praktikum12c.png)