# Praktikum 5 aruanne

Praktikum tutvustas mulle hulga erinevaid failiõiguste süsteeme. Sain ise teada, kuidas need ise töötavad, ja milleks
neid vaja on.

## Ülesanne 5.1
a) Kataloogi jaoks on vaja omanikul käivitamise õigusi ehk u=x ja faili lugemiseks lugemise õigusi u=r,
kuid eeldab, et tead, mis seal kataloogis juba on, muidu kataloogi õigustesse vaja lisada lugemise õigus.

b) Kataloogi jaoks on vaja kirjutamise ja käivitamise õigusi ehk u=wx ja faili jaoks kirjutamise õigusi ehk u=w. 

## Ülesanne 5.2
`chmod a=x skriptifail` ei ole piisav, kuna interpreeter ei saa faili lugeda. Ei saa skripti käivitada, kui ei tea
selle sisu.

## Ülesanne 5.3
Turvalisuse mõttes on tehtud nii, et igal kasutajal omanimeline grupp. Probleem on selles, et iga kasutaja 
peab kuuluma gruppi. Kui panna nad kõik ühte gruppi, siis pannakse umask=022, mis annab gruppile ainult lugemise õiguse, 
ja omanik peab ise andma grupile õiged õigused ja kasutajad ei ole selles alati usaldusväärsed. Seega lihtne lahendus on
anda grupile lugemise ja kirjutamise õiguse (umask=002) ja iga kasutaja on omas grupis, et vältida üht kasutajat 
kirjutamas üle teiste privaatfaile. 

## Ülesanne 5.4
Tavakasutajal, kes kuulub gruppi 'majasisene' vajab faili lugemiseks ainult lugemisõigust grupile, g=r.
![Tõestus](images/praktikum5.4.png)

## Ülesanne 5.5
Setuid õigust on vaja selleks, et programm saaks teha eleveeritud privileegidega midagi. Näiteks sudo kasutab setuid, et
käske root kasutajaõigustega jooksutada. 
![Tõestus](images/praktikum5.5.png)

## Ülesanne 5.6
Jah, setuid vähendab turvalisust, kui programm ei ole disainitud korralikult. Näiteks sudo programmil on olnud mitmeid
privileegi eskeleerivaid eksploite (vigu), üks nendest on CVE-2023-22809.

## Ülesanne 5.7
Sticky bit õigusetega kaustast saavad kustudada kasutaja peeter poolt loodud faile root, opetaja ja peeter.

## Ülesanne 5.8
ACL'i kasutamisel nägin käsus `ls -lah`, et pluss-märk on tekinud hinded.txt failile juurde ja gruppil on 
lugemis- ja kirjutamisõigused.
```
martin@maikov24:/home/opetaja/klass$ getfacl hinded.txt 
# file: hinded.txt
# owner: opetaja
# group: opetaja
user::rw-
group::---
group:direktor:rw-
mask::rw-
other::---
```

## Ülesanne 5.9
Mitte keegi ei saa `chattr +i` parameetriga faili muuta, sh kustutada, root-kasutaja saab ainult selle parameetri 
ära võta. Käsuga `chattr -i` saab selle parameetri ära võtta ning siis saab faili ära kustutada.
