# Praktikum 9 aruanne
Antud praktikumis sain iseseisvalt tutvuda programmidega, kust leida infot arvuti jõudluse kohta. Ülesande 9.15 jaoks sooviksin rohkem
praktilisemat ülesannet, et arvuti on ette antud ja on aeglane ning pean üles leidma, kuhu jõudlus kaotsi läheb. See annaks rohkem 
kogemusi ja kinnitaks seda teemat palju paremini, kui mingi teooriaküsimused, nagu mida ma teeksin. 

## Küsimuste vastused tabelis 

| Küsimus | Linux | Windows | Linuxis kasutatud käsklus | Windowsis kasutatud tööriist |
| --- | --- | --- | --- | --- |
| Mitu protsessi kokku arvutis käib? | 289 | 130 | `ps aux \| wc -l` | Tegumihaldur -> Jõudlus -> CPU |
| Milline on kõige esimesena käivitatud protsess? | `/sbin/init splash` | `smss.exe` | `ps axo pid,cmd,comm,etime \| head` | Process Explorer -> Start Time |
| Milliste kasutajate protsesse arvutis käib? | `avahi, colord, kernoops, martin, message+, root, rtkit, syslog, systemd+` | `Font Driver Host\UMFD-0, Font Driver Host\UMFD-1, Maikov-W11\Martin, NT_AUTHORITY\LOCAL SERVICE, NT_AUTHORITY\NETWORK SERVICE, NT_AUTHORITY\SYSTEM, Window Manager\DWM-1` | ` ps -ef \| tr -s " " \| tail -n+2 \| cut -d" " -f1 \| sort \| uniq` | Process Explorer -> User Name |
| Kui kaua on arvuti järjest töötanud (up time)? | 16 minutit | 19 minutit | `uptime -p` | Tegumihaldur -> Jõudlus -> CPU |
| Milline protsess käivitati kõige hiljem (viimasena)? | `[kworker/6:1ps ]` | `backgroundTaskHost.exe` | `ps axo pid,cmd,comm,etime --sort=+etimes \| tail -n +5 \| head` | Process Explorer -> Start Time |
| Milline on kõige rohkem protsessoriaega võttev protsess ja kui mitu protsenti protsessoriajast ta tarbib? | `/usr/bin/gnome-shell` ja 10.1% | `System` ja 2% | `ps axo pid,cmd,comm,pcpu --sort=-pcpu \| head` | Tegumihaldur -> Protsessid -> n% Protsessor |
| Milline on kõige rohkem virtuaalmälu (aadressiruumi, commit, Virtual Size) võttev protsess? | `/usr/bin/gnome-shell` | `msedgewebview2.exe` | `ps axo pid,cmd,comm,vsz --sort=-vsz \| head` | Process Explorer -> Virtual Size |
| Milline on kõige rohkem füüsilist mälu (working set) võttev protsess? | `/usr/libexec/gsd-smartcard` | `firefox.exe` | `ps axo pid,cmd,comm,sz --sort=-sz \| head` | Process Explorer -> Working Set |
| Kui palju füüsilisest mälust (Physical Memory) on vaba ja kui palju hõivatud? | 6,2 GiB on vaba (available) ja 1,2GiB on hõivatud (used) | 4,6 GB on vaba (saadaval) ja 3,3 GB on hõivatud (kasutusel) | `free -h` | Tegumihaldur -> Jõudlus -> Mälu |
| Kui palju on põhikettal (C:, /) vaba ruumi mahult (GB) ja protsentuaalselt? | 12GB ja 50% | 29,1 GB ja 46,2% | `df -h / \| awk 'NR==2 {print "Free Space: " $4 " (" 100 - $5 "% free)"}'` | Windows Explorer -> See arvuti ja Windows Powershell: `(Get-PSDrive -Name C).Free / ((Get-PSDrive -Name C).Used + (Get-PSDrive -Name C).Free) * 100` |
| Milline on kõige suurem arvutis olev fail ja kõige rohkem andmemahtu hõivav kaust (arvesse võta ka alamkaustade mahtu, ja jätta juurkaust / või C: välja)? | `/usr/lib/modules/6.8.0-48-generic/kernel/drivers/thunderbolt/thunderbolt.ko` ja `/usr` | `pagefile.sys` ja `Windows` | `du -ah / 2>&1 \| grep -v "^du:" \| sort -n -r \| head -n 5` ja `du -ah / 2>&1 \| grep -v "^du:" \| sort -n -r \| head -n 5` | WinDirStat |
| Võrrelge terminali käskude: `sha1sum /dev/zero \| sha1sum /dev/zero` ja `sha1sum /dev/urandom \| sha1sum /dev/urandom` protsessori kasutust. Võrdluseks avage teine terminaliaken ja top samaaegseks käivitamiseks. Uurige, millisele CPU alamtegevusele (us, sy, id, wa, st jne) kulub enim protsessori aega kummagi käsu puhul. | `id` oli mõlemal enim aega kuluv alamtegevus, aga `/dev/urandom/` käsu puhul oli kõrge ka `sys` alamtegevus  | Puudub | `top` ja `sha1sum /dev/urandom \| sha1sum /dev/urandom` ning `sha1sum /dev/zero \| sha1sum /dev/zero` | Puudub |
| Milline protsess kõige rohkem salvestusseadmele kirjutab? | Puudub | `TiWorker.exe` | Puudub | Resource Monitor -> Disk |
| Millisesse faili eelmise küsimuse protsess kõige rohkem kirjutab? | Puudub | `C:\Windows\Logs\CBS\CBS.log` | Puudub | Resource Monitor -> Disk |
| Milline protsess kõige rohkem salvestusseadmelt loeb? | Puudub | `MoUsocoreWorker.exe` | Puudub | Resource Monitor -> Disk |
| Millisest failist eelmise küsimuse protsess kõige rohkem loeb? | Puudub | `C:\Windows\System32\SustainabilityService.dll` | Puudub | Resource Monitor -> Disk |
| Millise protsessi poolt tekitatud võrguliiklus on suurima mahuga? Vali antud protsessi poolt kasutatavatest ühendustest üks ning kirjuta välja järgnev: kohalik IP-aadress, kohalik port, ühenduse teise poole IP-aadress, port, latents ja antud ühenduse poolt kasutatav võrguliikluse kogumaht. | Puudub | `nextcloud.exe`, 10.0.2.15, 49692, 193.40.5.90, 1 ms, 177 baiti sekundis. | Puudub | Resource Monitor -> Network |

## Ülesanne 9.15
**Sõber kurdab, et tema arvuti on oluliselt aeglasemaks muutunud. Milliseid konkreetseid programme või käsureakäske kasutad põhjustaja tuvastamiseks. Mõlemal juhul kirjuta, mida konkreetselt jälgid (nt mis aken, veerud, numbrid jne).**

### Windows

1. Tegumihaldur -- sealt vaatan Protsesside vaate alt protsessori kasutusaega, mälukasutust ja ketta utilisatsiooni. Süüdioleva protsessiga lõpetatakse toiming ehk protsess, mis võtab liiga palju arvuti jõudlust.
2. Uurin tegumihalduris käivitusrakendusi vajadusel võtan vähemaks neid.
3. Lasen antiviiruse skanneri tööle, kasutades programme MS Defender ja Malwayebytes
4. Vajadusel vaatan ka Resource Monitor'isse ja uurin kuhu jõudlus läheb, vaadates kõik vahelehed läbi, nagu Overview, CPU, Memory, Disk, Network
5. Vajadusel sirvin läbi Process Exploreri ja vaatan, kus suured numbrid tuplades asuvad.


## Ülesande 9.12 tõestus
![Tõestus](images/praktikum9.12.png)

## Ülesande 9.14 tõestus
![Tõestus](images/praktikum9.14.png)
